//+------------------------------------------------------------------+
//|                                                       EA CCI.mq5 |
//|                                                      Aleksej1966 |
//|                        https://www.mql5.com/ru/users/aleksej1966 |
//+------------------------------------------------------------------+
#property copyright "Aleksej1966"
#property link      "https://www.mql5.com/ru/users/aleksej1966"
#property version   "1.00"
#include <Trade\Trade.mqh>
CTrade trade;

input ushort iPeriod=310,
             LvlOpen=15,
             LvlClose=70,
             LvlStDev=40;

input short Filter=-1;

char buy,sell;
int period,indx,open[][2];
double lot;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   trade.SetDeviationInPoints(10);
   trade.SetAsyncMode(true);
   trade.SetTypeFillingBySymbol(_Symbol);

   period=2*MathMax(1,iPeriod)+1;
   indx=period/2;
   ArrayResize(open,period);

   lot=SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);

   int bars=MathMin(iBars(_Symbol,PERIOD_CURRENT),TerminalInfoInteger(TERMINAL_MAXBARS));

   for(int i=bars-period-2; i>=0; i--)
      CalcSignal(i);

   NewBar();
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
//---
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   if(NewBar()==true)
     {
      CalcSignal(0);

      if(buy>0)
         trade.PositionOpen(_Symbol,ORDER_TYPE_BUY,lot,SymbolInfoDouble(_Symbol,SYMBOL_ASK),0,0,NULL);

      if(sell>0)
         trade.PositionOpen(_Symbol,ORDER_TYPE_SELL,lot,SymbolInfoDouble(_Symbol,SYMBOL_BID),0,0,NULL);

      if(buy<0 || sell<0)
        {
         ENUM_POSITION_TYPE type=buy<0?POSITION_TYPE_BUY:POSITION_TYPE_SELL;
         for(int i=PositionsTotal()-1; i>=0; i--)
           {
            ulong ticket=PositionGetTicket(i);
            if(PositionSelectByTicket(ticket)==true && type==(ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE))
               trade.PositionClose(ticket,10);
           }
        }
     }
//---
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CalcSignal(int bar)
  {
//---
   static int array[][2],size1,mad[][2],size2,cnt;

   if(size1==0)
     {
      ArrayResize(array,0,100);
      ArrayResize(mad,0,100);
     }

   int cur_open=(int)MathRound(iOpen(_Symbol,PERIOD_CURRENT,bar)/_Point);
   open[0][0]=cur_open;
   open[0][1]=0;

   for(int i=1; i<period; i++)
     {
      open[i][0]=(int)MathRound(iOpen(_Symbol,PERIOD_CURRENT,bar+i)/_Point);
      open[i][1]=i;
     }

   ArraySort(open);

   int median=open[indx][0],num=open[indx][1];

   if(Filter>-1 && Filter!=num)
      return;

   int diff=cur_open-median,ind=ArrayBsearch(array,diff);

   if(ind>=0 && array[ind][0]==diff)
      array[ind][1]++;
   else
     {
      ArrayResize(array,size1+1);
      array[size1][0]=diff;
      array[size1][1]=1;
      size1++;
      ArraySort(array);
     }

   for(int i=0; i<period; i++)
      open[i][0]=MathAbs(open[i][0]-median);

   ArraySort(open);
   int stdev=open[indx][0];
   ind=ArrayBsearch(mad,stdev);

   if(ind>=0 && mad[ind][0]==stdev)
      mad[ind][1]++;
   else
     {
      ArrayResize(mad,size2+1);
      mad[size2][0]=stdev;
      mad[size2][1]=1;
      size2++;
      ArraySort(mad);
     }

   cnt++;

   if(bar==0)
     {
      int lvlst=0,buyopen=0,buyclose=0,sellopen=0,sellclose=0,sum=0;

      for(int i=size2-1; i>=0; i--)
        {
         sum=sum+mad[i][1];
         if(100*sum<=LvlStDev*cnt)
            lvlst=mad[i][0];
         else
            break;
        }

      sum=0;
      for(int i=0; i<size1; i++)
        {
         sum=sum+array[i][1];

         if(100*sum<=LvlOpen*cnt)
            buyopen=array[i][0];

         if(100*sum<=LvlClose*cnt)
            buyclose=array[i][0];
         else
            break;
        }

      sum=0;
      for(int i=size1-1; i>=0; i--)
        {
         sum=sum+array[i][1];

         if(100*sum<=LvlOpen*cnt)
            sellopen=array[i][0];

         if(100*sum<=LvlClose*cnt)
            sellclose=array[i][0];
         else
            break;
        }

      buy=0;
      sell=0;

      if(lvlst>=stdev)
        {
         if(diff<=buyopen)
            buy++;
         if(diff>=sellopen)
            sell++;
        }
      if(diff>=buyclose)
         buy--;
      if(diff<=sellclose)
         sell--;
     }
//---
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool NewBar()
  {
//---
   static long lastbar;
   long curbar=SeriesInfoInteger(_Symbol,PERIOD_CURRENT,SERIES_LASTBAR_DATE);
   if(lastbar<curbar)
     {
      lastbar=curbar;
      return(true);
     }
   return(false);
//---
  }
//+------------------------------------------------------------------+
